<template>
  <el-dialog
      :title="title"
      :visible.sync="open"
      width="30%"
      :close-on-click-modal="false"
      :destroy-on-close="true"
      :append-to-body="true">
    <el-tree
        style="padding-bottom: 30px"
        ref="tree"
        :data="treeData"
        node-key="id"
        :expand-on-click-node="false"
        :default-expand-all="true"
        :highlight-current="true"
        :check-strictly="true"
        @check-change="setCurrentCheck"
        :default-expanded-keys="[1, 1]"
        show-checkbox
        :props="defaultProps">
    </el-tree>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close" size="small">取 消</el-button>
      <el-button type="primary" @click="save" size="small">确 定</el-button>
    </div>
  </el-dialog>
</template>

<script>
export default {
  name: "TreeDialog",
  data() {
    return {
      open: false,
      selectOrg: null,
      defaultProps: {
        children: 'children',
        label: 'orgName'
      }
    }
  },
  props: {
    treeData: {
      type: Array
    },
    title: {
      type: String
    }
  },
  methods: {
    // 回显
    setChecked(id) {
      this.open = true
      this.$nextTick(() => {
        if (id) {
          this.$refs.tree.setCheckedKeys([id])
        }
      })
    },
    // 单选控制
    setCurrentCheck(data, checked) {
      if (checked) {
        this.$refs.tree.setCheckedKeys([data.id])
        this.selectOrg = data
      } else {
        this.selectOrg = null
      }
    },
    save(){
      this.$emit("save", this.selectOrg)
    },
    close() {
      this.open = false
    }
  }
}
</script>

<style scoped>

</style>
